﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Controls.Menus;
using System.Collections.Specialized;
using System.Windows;

namespace DockWithTheme
{
    public class CustXamDataTree : XamDataTree
    {
        private bool IsSetFromNodeChanged = false;
        private static XamDataTreeNodesCollection nodes;
    
        public CustXamDataTree()
        {
           base.ActiveNodeChanged += new EventHandler<ActiveNodeChangedEventArgs>(CustXamDataTree_ActiveNodeChanged);
           nodes = Nodes;
        }

        void CustXamDataTree_ActiveNodeChanged(object sender, ActiveNodeChangedEventArgs e)
        {
            IsSetFromNodeChanged = true;
            SelectedItem = e.NewActiveTreeNode.Data;
        }

        public object SelectedItem
        {
            get { return (object)GetValue(SelectedItemsProperty); }
            set 
            { 
                SetValue(SelectedItemsProperty, value);

            }
        }

        private static void FindCorrespondingNode(XamDataTreeNodesCollection nodes, object value)
        {
            foreach (XamDataTreeNode node in nodes)
            {
                if (node.Data.Equals(value))
                {
                    node.IsActive = true;
                    node.IsSelected = true;
                    return;
                }
                if (node.HasChildren)
                {
                    FindCorrespondingNode(node.Nodes, value);
                }

            }
        }

        public static readonly DependencyProperty SelectedItemsProperty = DependencyProperty.Register(
            "SelectedItem",
            typeof(object),
            typeof(CustXamDataTree),
            new FrameworkPropertyMetadata(null,FrameworkPropertyMetadataOptions.AffectsRender,
                new PropertyChangedCallback(OnPropertyChangedCallback)));

        public static void OnPropertyChangedCallback(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            FindCorrespondingNode(nodes, e.NewValue);
        }
    }
}
